/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _container = __webpack_require__(1);
	
	var _container2 = _interopRequireDefault(_container);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	window.createContainer = _container2.default; /* global window */

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = createContainer;
	
	var _utils = __webpack_require__(2);
	
	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }
	
	/**
	 * @typedef   {Object}    Container
	 * @property  {Function}  add
	 * @property  {Function}  share
	 * @property  {Function}  get
	 */
	
	/**
	 * @return {Container}
	 */
	function createContainer() {
	  // eslint-disable-line max-statements
	  var dependencies = [];
	
	  /**
	   * Registers a depedency at the container.
	   *
	   * @param {string}    name      Dependency name
	   * @param {Function}  func      Constructor or factory function
	   * @param {Array}     [args=[]] Dependency arguments to inject
	   */
	  function add(name, func) {
	    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
	
	    validateRegistrationArguments(name, func, args, 'add');
	    var dependency = { name: name, func: func, args: args };
	    dependencies = [].concat(_toConsumableArray(dependencies), [dependency]);
	  }
	
	  /**
	   * Registers a singleton depedency at the container.
	   *
	   * @param {string}    name      Dependency name
	   * @param {Function}  func      Constructor or factory function
	   * @param {Array}     [args=[]] Dependency arguments to inject
	   */
	  function share(name, func) {
	    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
	
	    validateRegistrationArguments(name, func, args, 'share');
	    var dependency = { name: name, func: func, args: args, shared: true };
	    dependencies = [].concat(_toConsumableArray(dependencies), [dependency]);
	  }
	
	  /**
	   * Get an instantiated, injected dependency from the container.
	   *
	   * @param {string}  name  Dependency name
	   * @return {*}  Resolved dependency
	   */
	  function get(name) {
	    (0, _utils.validateArguments)([name], 'get', { name: ['string', true] });
	    var dependency = findDependency(name);
	    (0, _utils.invariant)(dependency, 'Dependency \'' + name + '\' does not exist.');
	    return instantiate(dependency);
	  }
	
	  function instantiate(_ref) {
	    var name = _ref.name,
	        func = _ref.func,
	        instance = _ref.instance,
	        args = _ref.args,
	        shared = _ref.shared;
	
	    if (shared) {
	      return instance || createSingle(name, func, instance, args);
	    }
	
	    return create(func, args);
	  }
	
	  function create(func, args) {
	    var resolvedArgs = args.map(get);
	    return func.hasOwnProperty('prototype') ? new (Function.prototype.bind.apply(func, [null].concat(_toConsumableArray(resolvedArgs))))() : // eslint-disable-line new-cap
	    func.apply(undefined, _toConsumableArray(resolvedArgs));
	  }
	
	  function createSingle(name, func, instance, args) {
	    var newInstance = create(func, args);
	    dependencies = setInstance(name, newInstance);
	    return newInstance;
	  }
	
	  function findDependency(name) {
	    return dependencies.find(function (dep) {
	      return dep.name === name;
	    });
	  }
	
	  function setInstance(name, instance) {
	    return dependencies.map(function (dep) {
	      return name === dep.name ? _extends({}, dep, { instance: instance }) : dep;
	    });
	  }
	
	  function validateRegistrationArguments(name, func, args, type) {
	    (0, _utils.validateArguments)([name, func, args], type, {
	      name: ['string', true],
	      constructor: ['function', true],
	      arguments: ['array']
	    });
	    (0, _utils.invariant)(!findDependency(name), 'Dependency \'' + name + '\' already exists.');
	  }
	
	  return { add: add, share: share, get: get };
	}
	module.exports = exports['default'];

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	exports.validateArguments = validateArguments;
	exports.invariant = invariant;
	var indices = ['First', 'Second', 'Third'];
	
	function validateArguments(args, func, options) {
	  Object.keys(options).map(function (name, index) {
	    var _options$name = _slicedToArray(options[name], 2),
	        expected = _options$name[0],
	        required = _options$name[1];
	
	    var value = args[index];
	    var type = Array.isArray(value) ? 'array' : typeof value === 'undefined' ? 'undefined' : _typeof(value);
	    var matches = type === expected;
	
	    return invariant(required ? matches : value === undefined || matches, indices[index] + ' argument of ' + func + ' should be the ' + name + ' of type \'' + expected + '\', got \'' + (typeof value === 'undefined' ? 'undefined' : _typeof(value)) + '\'.');
	  });
	}
	
	function invariant(condition, message) {
	  if (!condition) {
	    throw new Error(message);
	  }
	}

/***/ }
/******/ ]);
//# sourceMappingURL=containor.js.map